import re
from collections import defaultdict

def number_repated_words(text):
    word_frequency = defaultdict(int)
    word_counter = defaultdict(int)
    pattern = r"[a-zA-ZõäöüÕÄÖÜ]+"

    words = re.findall(pattern, text)
    for word in words:
        word_frequency[word.lower()] += 1

    def replaced_word(match):
        word = match.group()
        if word_frequency[word.lower()] > 1:
            word_counter[word.lower()] += 1
            return word + "#" +str(word_counter[word.lower()])
        else:
            return word
    new_text = re.sub(pattern, replaced_word, text)
    return new_text

text = "Tere, sõber! Tere, tere armas sõber."
new_text = number_repated_words(text)
print(new_text)